是否可以使用 Autodesk.AutoCAD.Interop 在 AutoCAD 中编辑块属性?

Posted

技术标签:

【中文标题】是否可以使用 Autodesk.AutoCAD.Interop 在 AutoCAD 中编辑块属性?【英文标题】:Is it possible to edit block attributes in AutoCAD using Autodesk.AutoCAD.Interop? 【发布时间】:2013-10-17 20:59:21 【问题描述】:

我开发了一个外部 WPF 应用程序来在 c# 中生成绘图。我已经能够使用 Autodesk.AutoCAD.Interop 绘制、标注、添加块以及应用程序所需的所有其他内容,但是我似乎无法填充标题栏或生成零件列表。

我看到的所有示例都基于要求应用程序在 AutoCAD 中作为插件运行的机制。事实是,使用ModelSpace.InsertLine插入一行是一两行代码,现在,至少是8行代码!

有没有办法使用 Autodesk.AutoCAD.Interop 实现此功能?或者有没有办法将互操作与可以从外部 exe 调用的插件结合使用?

任何关于此的指针将不胜感激。

谢谢。

编辑 举例说明:

// before - Draw Line with Autodesk.AutoCAD.Interop
private static AcadLine DrawLine(double[] startPoint, double[] endPoint)

    AcadLine line = ThisDrawing.ModelSpace.AddLine(startPoint, endPoint);
    return line;

// Now - Draw line with Autodesk.AutoCAD.Runtime
[CommandMethod("DrawLine")]
public static Line DrawLine(Coordinate start, Coordinate end)

    // Get the current document and database 
    // Get the current document and database
    Document acDoc = Application.DocumentManager.MdiActiveDocument;
    Database acCurDb = acDoc.Database;

    // Start a transaction
    using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())
    
        // Open the Block table for read
        BlockTable acBlkTbl;
        acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead) as BlockTable;

        // Open the Block table record Model space for write
        BlockTableRecord acBlkTblRec;
        acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;

        // Create a line that starts at 5,5 and ends at 12,3
        Line acLine = new Line(start.Point3d, end.Point3d);

        acLine.SetDatabaseDefaults();

        // Add the new object to the block table record and the transaction
        acBlkTblRec.AppendEntity(acLine);
        acTrans.AddNewlyCreatedDBObject(acLine, true);

        // Save the new object to the database
        acTrans.Commit();
        return acLine;
    

【问题讨论】:

值得注意的是,尽管使用 AcMdg.dll 和 AcDbMdg.dll 的 AutoCAD 内部开发通常涉及更多,但与 Interop 对应物相比,它的效率很高。 @reckface - 请告诉我,您如何在不显式打开 AutoCad 的情况下向其发送命令。可以通过纯.Net代码来完成吗? 我有一个适当地称为 CAD 的包装器类。我调用 CAD.Setup(),它会创建一个新的 AutoCAD.Application(如果尚未创建),然后调用 app.Documents.Add 或创建,然后 CAD 类会从那里包装我对文档的所有调用。这是一个带有 ClickOnce 部署的纯 .Net exe 安装。 【参考方案1】:

是的,你完全可以将这两种方法结合起来。

    编写一个在 AutoCAD 中执行工作的进程内 DLL。通过使用 [CommandMethod("MethodName")] 标记您的公共方法,使您希望调用的命令可用于命令行。

    通过互操作调用启动或连接 AutoCAD。

    使用互操作 AcadApplication,网络加载您的 DLL,然后从命令行调用您的工作函数。

*Bonus * 您也可以通过这种方式更轻松地将互操作参数传递给内部命令。

这是一个如何在进程中构建命令方法然后通过 COM 调用它的示例:

[CommandMethod("EditBlockAtt")]
public void EditBlockAtt()

    var acDb = HostApplicationServices.WorkingDatabase;
    var acEd = AcadApplication.DocumentManager.MdiActiveDocument.Editor;

    var blockNamePrompt = acEd.GetString(Environment.NewLine + "Enter block name: ");
    if (blockNamePrompt.Status != PromptStatus.OK) return;
    var blockName = blockNamePrompt.StringResult;

    var attNamePrompt = acEd.GetString(Environment.NewLine + "Enter attribute name: ");
    if (attNamePrompt.Status != PromptStatus.OK) return;
    var attName = attNamePrompt.StringResult;

    var acPo = new PromptStringOptions(Environment.NewLine + "Enter new attribute value: ") AllowSpaces = true ;
    var newValuePrompt = acEd.GetString(acPo);
    if (newValuePrompt.Status != PromptStatus.OK) return;
    var newValue = newValuePrompt.StringResult;

    using (var acTrans = acDb.TransactionManager.StartTransaction())
    
        var acBlockTable = acTrans.GetObject(acDb.BlockTableId, OpenMode.ForRead) as BlockTable;
        if (acBlockTable == null) return;

        var acBlockTableRecord = acTrans.GetObject(acBlockTable[BlockTableRecord.ModelSpace], OpenMode.ForRead) as BlockTableRecord;
        if (acBlockTableRecord == null) return;

        foreach (var blkId in acBlockTableRecord)
        
            var acBlock = acTrans.GetObject(blkId, OpenMode.ForRead) as BlockReference;
            if (acBlock == null) continue;
            if (!acBlock.Name.Equals(blockName, StringComparison.CurrentCultureIgnoreCase)) continue;
            foreach (ObjectId attId in acBlock.AttributeCollection)
            
                var acAtt = acTrans.GetObject(attId, OpenMode.ForRead) as AttributeReference;
                if (acAtt == null) continue;

                if (!acAtt.Tag.Equals(attName, StringComparison.CurrentCultureIgnoreCase)) continue;
                    
                acAtt.UpgradeOpen();
                acAtt.TextString = newValue;
            
        

        acTrans.Commit();
    

然后从一个互操作的 AcadApplication 中,网络加载 dll 并以这种格式从命令行调用该方法:

(Command "EditBlockAtt" "BlockName" "AttributeName" "NewValue")

但是,如果您想使用纯互操作,如果您在运行时有一个 AcadDocument 对象,这可能会满足您的需求:

foreach (AcadEntity ent in acadDoc.ModelSpace)

    var block = ent as AcadBlockReference;
    if (block == null) continue;
    
        if (!block.Name.Equals("BlockName", StringComparison.CurrentCultureIgnoreCase)) continue;
        var atts = block.GetAttributes() as object[];
        if (atts == null) continue;

        foreach (var attribute in atts.OfType<AcadAttributeReference>()
            .Where(attribute => attribute.TagString.Equals("AttributeName", 
                                StringComparison.CurrentCultureIgnoreCase)))
        
            attribute.TextString = "New Value";
        
    

另请注意,这是使用 AutoCAD 2012 互操作库。 YMMV。

【讨论】:

不得不等到我面前有一个 IDE 才能扩展我的答案以包含互操作方法。如果您发现这在较大的图纸上需要一段时间,则可能值得事先将选择过滤为仅块,然后迭代它而不是整个模型空间。 谢谢。我正在考虑实施新的 acMdg.dll .net 引用,但截止日期限制意味着我必须现在制作一些东西,然后再花更多时间更好地理解界面。昨天我将所有内容都剥离到 acMdg.dll 并发现你不能独立运行它,我不得不快速回溯到互操作!再次感谢,我将努力结合这两种方法。 @Parrish - 请告诉我,您如何在不显式打开 AutoCad 的情况下向其发送命令。可以通过纯.Net代码来完成吗? @RohitVats,对 AutoCAD 的进程内 .NET 调用假定正在运行的应用程序。但是,您可以通过 Interop 实例化 AutoCAD,然后将进程内命令发送到新运行的实例。你的目标到底是什么? 我正在编写一个软件,它将加载 dwg 文件,从中挑选一些块,修改它(设置一些属性等),分解它并将其保存在新的 dwg 文件中。但现在我正在努力从进程本身打开 AutoCAD。它总是因一些 COM 异常而失败。 :( 我已经尝试过这里提到的两种方法 - ***.com/questions/24389965/… 但它们都不适合我。(通过编组尝试并尝试创建 AcadApplication 的实例)

以上是关于是否可以使用 Autodesk.AutoCAD.Interop 在 AutoCAD 中编辑块属性?的主要内容,如果未能解决你的问题,请参考以下文章

是否可以使用 JavaScript 确定 GeoJSON 点是否在 GeoJSON 多边形内?

是否可以检查是否使用modernizr 启用了cookie?

是否可以使用 HTML/Javascript 按名称启动应用程序?

是否可以使用 jQuery 读取元标记

是否可以使用批处理文件检查两个文件是否共享相同的名称?

是否可以使用 INFORMATION_SCHEMA 模式来检查数据库是否存在?